#ifndef INTERFACE_H
#define INTERFACE_H 1

#include <gnome-xml/tree.h>
#include <gnome-xml/parser.h>
#include "list.h"
#include "macaddress.h"

class Subnet;
class Network;
class Device;
class Interface
{
	public:
		Interface();
		~Interface();

		void empty();
		void print();
		void savexml(xmlNodePtr xmlnode);
		void loadxml(xmlNodePtr xmlnode, List *mch);
		int match(char *str);
		int matchsubnet(Subnet *s);

		int index;
		MACAddress mac;
		unsigned long speed;
		int type;
		char status;
		char duplex;
		char portfast;
		char descr[65];
		char comment[129];
		List ip_addresses;
		Network *network;
		Device *device;
		List machines;
		List refs;
		List nexthops;
		char switch_list_flag;	// dirty bit for switch list (should be gboolean)
};

#endif

