#include <stdlib.h>
#include <string.h>
#include "subnet.h"
#include "misc.h"

Subnet::Subnet()
{
	empty();
}

Subnet::~Subnet()
{
}

void Subnet::empty()
{
	strcpy(name, "");
	ip.empty();
	gateway.empty();
	mask = 0;
	find = '0';
}

void Subnet::savexml(xmlNodePtr xmlnode)
{
	xmlNodePtr newxml;
	char buf[32];
// printf("Save subnet xml %s %s %d\n", name, ip.getstring(), mask);
	newxml = xmlNewChild(xmlnode, NULL, (xmlChar*)"Subnet", NULL);
	if (strcmp(name, "")!=0)
		xmlSetProp(newxml, (xmlChar*)"name", (xmlChar*)name);
	xmlSetProp(newxml, (xmlChar*)"gateway", (xmlChar*)gateway.getstring());
	xmlSetProp(newxml, (xmlChar*)"ip", (xmlChar*)ip.getstring());
	sprintf(buf, "%d", mask);
	xmlSetProp(newxml, (xmlChar*)"mask", (xmlChar*)buf);
}

void Subnet::loadxml(xmlNodePtr xmlnode)
{
	xmlChar *buf;

	if (!xmlnode || !xmlnode->name || strcmp((char*)xmlnode->name, "Subnet")!=0)
		return;
	buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"name");
	if (buf!=NULL) { strcpy(name, (char*)buf); free(buf); }
	buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"gateway");
	if (buf!=NULL) { gateway.setstring((char*)buf); free(buf); }
	buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"ip");
	if (buf!=NULL) { ip.setstring((char*)buf); free(buf); }
	buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"mask");
	if (buf!=NULL) { sscanf((char*)buf, "%d", &mask); free(buf); }
// printf("Load subnet xml %s %s %d\n", name, ip.getstring(), mask);
}

char *Subnet::getstring()
{
	static char buf[64];
	sprintf("%s/%d", ip.getstring(), mask);
	return buf;
}

void Subnet::setstring(char *str)
{
	char tip[64];
	sscanf(str, "%[^/]/%d", tip, &mask);
	ip.setstring(tip);
}

int Subnet::match(char *str)
{
	char nm[256];

	if (strlen(str)==0) return 0;

	if ((strlen(name)>0) && (lower_contains(name, str))) return 1;

	sprintf(nm, "%s/%d", ip.getstring(), mask);
	if (lower_contains(nm, str)) return 2;

	return 0;
}

void Subnet::print()
{
	printf("%s/%d\n", ip.getstring(), mask);
}
